classdef MyNetworkVec < handle
    properties
        depth;
        w;
        b;
    end
    
    
    methods (Static)
        %sigmoid function
        function y = sigmaF(x)            
            % TODO
            y = 0;
        end
        
        %differentiated sigmoid
        function y = sigmaP(x)
            % TODO
            y = 0;
        end
    end
    
    methods
        % constructor
        % sz - vector of layer sizes e.g. [28*28 30 30 10]
        function obj = MyNetworkVec(sz)
            obj.depth = length(sz);
            obj.b = cell(1,obj.depth);
            obj.w = cell(1,obj.depth);
            w{1} = [];
            b{1} = [];
            for i = 2:obj.depth
               obj.b{i} = randn(sz(i),1);
               obj.w{i} = randn(sz(i),sz(i-1)); 
            end     
        end
        
        % forward run
        function a = feedFwd(obj,a)
            % TODO
            a = 0;
        end
        
        
        % train and evaluate accuracy on val set after each epoch
        % dmanager - DataManager object for MNIST
        % ep - number of epochs of training
        % mb - minibatch size
        % eta - eta for SGD
        % lambda - regularization parameter
        function evaltrain(obj,dmanager,ep,mb,eta,lambda)
%             old = 0;
%             cont = true;
            cnt = 0;
            while(cnt<ep)
                new = obj.eval(dmanager);
                fprintf('After %i epochs %i numbers were correctly classified \r\n',cnt,new);
                obj.train(dmanager,mb,eta,lambda);             
                cnt = cnt + 1;
            end
            new = obj.eval(dmanager);
            fprintf('Finally: after %i epochs %i numbers were correctly classified \r\n',cnt,new);
        end
        
        % outputs how many members of val set were correctly classified
        function s = eval(obj,dmanager)
            res = obj.feedFwd(dmanager.valImVecs);
            [~,i] = max(res);
            s = sum(i-1 == dmanager.valLab);
        end
        
        % prepare minibatches and run them
        % dmanager - DataManager object
        % mbSize - minibatch size
        % eta - SGD parameter
        % lambda - regularization parameter
        function train(obj,dmanager,mbSize,eta,lambda)
            % reshuffle train set
            dmanager = dmanager.initBatches(mbSize);
            % loop over minibatches until one epoch is done
            while(dmanager.cont)
                [imVec,labVec] = dmanager.getBatch;
                obj.trainMini(imVec,labVec,eta,lambda/dmanager.trainSize);
            end
        end
        
        % perform one step of SGD on one minibatch
        % imVec - matrix with columns representing each input image
        %         in the minibatch
        % labVec - matrix with columns representing each output label 
        %          vector in the minibatch
        % eta - parameter for SGD
        % scaledLambda - regularization parameter divided by size of the
        %                training set
        function err = trainMini(obj,imVec,labVec,eta,scaledLambda)
            neww = obj.w;
            newb = obj.b;
            m = size(imVec,2);
            err = 0;
            
            % TODO            
            
            obj.w = neww;
            obj.b = newb;
        end
    end
    
end